﻿601,100
562,"NULL"
586,
585,
564,
565,"rCNN4=yNa@Wu0Mb\\taqs:S[nyM\FnHEISdjN6gRCY=[y8=SabQk<r4x7Bn6eO[vWyC?THhN47HL`B:PdHrdheb^ihFd7ZsWm5s0^3kPkMjA9Nu\85E6uS4vWF^`Wqnhq7bW`f7T0olR=@[tSSaNwQPB[qoPXVyo1ks6TU0TRvs^13F8zDWULDRBE:53uKduv?^]?_dP"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,4
pExecutionId
pTime
pAppId
pControl
561,4
2
2
2
2
590,4
pExecutionId,"None"
pTime,"0"
pAppId,"MyApp"
pControl,"N"
637,4
pExecutionId,
pTime,
pAppId,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,226


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_reset_state';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_log_file_names', 
'pExecutionId', pExecutionId, 'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cConfigDim = cControlPrefix | 'tp_config';
If (DimensionExists(cConfigDim) = 1);
cGenerateLog = ATTRS(cControlPrefix | 'tp_config', 'Generate TI Log', 'String Value');
Else;
cGenerateLog = 'N';
EndIf;

#*** Log Parameters

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Parameters:', TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 
pExecutionId, pAppId, pControl);
EndIf;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check application dimension');
EndIf;

cApplicationsDim = cControlPrefix | 'tp_applications';

If (DimensionExists(cApplicationsDim) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_DIM_NOT_EXIST',
'pErrorDetails', cApplicationsDim,
'pControl', pControl);

ProcessError;
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check application id', pAppId);
EndIf;

If (DIMIX(cApplicationsDim, pAppId) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', cApplicationsDim | ', ' | pAppId,
'pControl', pControl);

ProcessError;
EndIf;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check state cube');
EndIf;

cStateCube = cControlPrefix | 'tp_application_state}' | pAppId;
If(CubeExists(cStateCube) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_CUBE_NOT_EXIST',
'pErrorDetails', cStateCube,
'pControl', pControl);

ProcessError;
EndIf;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check all view');
EndIf;

cAllView = 'All';
If (ViewExists(cStateCube, cAllView) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_VIEW_NOT_EXIST',
'pErrorDetails', cStateCube | ': ' | cAllView,
'pControl', pControl);

ProcessError;
EndIf;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Get Approval dimension and subset');
EndIf;

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');
StringGlobalVariable('gApprovalSubsetComplementMdx');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_application_attributes', 
'pExecutionId', pExecutionId, 'pAppId', pAppId, 'pControl',  pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cApprovalDim = gApprovalDim;
cApprovalSubset = gApprovalSubset;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Revoke all owners');
EndIf;

vReturnValue = ExecuteProcess( cControlPrefix | 'tp_clean_approval_owner_groups',
'pExecutionId', pExecutionId, 
'pAppId', pAppId, 
'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Zero out all view');
EndIf;

ViewZeroOut(cStateCube, cAllView);

#*** 
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Set node state to Not Started if the node is in the subset');
EndIf;

#*** 

cApprovalDimSize = DIMSIZ(cApprovalDim);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Set state cube value for state if the node is in the subset');
EndIf;

cDisplayUserName = ATTRS('}Clients', TM1User, '}TM1_DefaultDisplayValue');
If (cDisplayUserName @= '');
cDisplayUserName = TM1User;
EndIf;

cState = 'State';
cStateChangeUser = 'StateChangeUser';
cStateChangeDate = 'StateChangeDate';

vIndex = 1;
While (vIndex <= cApprovalDimSize);
vElement = DIMNM(cApprovalDim, vIndex);

vValue = CellGetS(cStateCube, vElement, 'State');
If (vValue @= '');
CellPutS('0', cStateCube, vElement, cState);
CellPutS(cDisplayUserName, cStateCube, vElement, cStateChangeUser);
CellPutS(pTime, cStateCube, vElement, cStateChangeDate);
EndIf;

vIndex = vIndex + 1;
End;

#***

cNodeInfoDim = cControlPrefix | 'tp_node_info';

If (gApprovalSubsetComplementMdx @<> '');

vApprovalSubsetComplement = 'tp_temp_approval_subset_complement_' | pExecutionId;
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'approval subset complement: ' | vApprovalSubsetComplement);
EndIf;

SubsetDestroy(cApprovalDim, vApprovalSubsetComplement);
SubsetCreateByMdx(vApprovalSubsetComplement, gApprovalSubsetComplementMdx);

vComplementView = 'tp_temp_view_' | pExecutionId;
ViewCreate(cStateCube, vComplementView);
ViewColumnDimensionSet(cStateCube, vComplementView, cNodeInfoDim, 1);
ViewRowDimensionSet(cStateCube, vComplementView, cApprovalDim, 1);
ViewSubsetAssign(cStateCube, vComplementView, cApprovalDim, vApprovalSubsetComplement);

ViewZeroOut(cStateCube, vComplementView);
ViewDestroy(cStateCube, vComplementView);

SubsetDestroy(cApprovalDim, vApprovalSubsetComplement);

EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;


573,1

574,1

575,1

576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
