﻿601,100
562,"NULL"
586,
585,
564,
565,"rCNN4=yNa@Wu0Mb\\taqs:S[nyM\FnHEISdjN6gRCY=[y8=SabQk<r4x7Bn6eO[vWyC?THhN47HL`B:PdHrdheb^ihFd7ZsWm5s0^3kPkMjA9Nu\85E6uS4vWF^`Wqnhq7bW`f7T0olR=@[tSSaNwQPB[qoPXVyo1ks6TU0TRvs^13F8zDWULDRBE:53uKduv?^]?_dP"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,5
pExecutionId
pTime
pAppId
pNode
pControl
561,5
2
2
2
2
2
590,5
pExecutionId,"None"
pTime,"0"
pAppId,"MyApp"
pNode,"NA"
pControl,"N"
637,5
pExecutionId,
pTime,
pAppId,
pNode,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,191


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_workflow_enter_node';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_log_file_names', 'pExecutionId', pExecutionId,
'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cConfigDim = cControlPrefix | 'tp_config';
If (DimensionExists(cConfigDim) = 1);
cGenerateLog = ATTRS(cConfigDim, 'Generate TI Log', 'String Value');
Else;
cGenerateLog = 'N';
EndIf;

#*** Get lock

cLock = 'Lock';
cId = 'Id';
cSemaphoreCube = cControlPrefix | 'tp_semaphore';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Start getting lock');
EndIf;

CellPutS(pExecutionId, cSemaphoreCube, cLock, cId);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Finish getting lock');
EndIf;

#*** Log Parameters

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:', pExecutionId, pTime, pAppId, pNode, pControl);
EndIf;

#***

cDisplayUserName = ATTRS('}Clients', TM1User, '}TM1_DefaultDisplayValue');
If (cDisplayUserName @= '');
cDisplayUserName = TM1User;
EndIf;

#*** 

cStateCube = cControlPrefix | 'tp_application_state}' | pAppId;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check state cube: ' | cStateCube);
EndIf;

If(CubeExists(cStateCube) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_CUBE_NOT_EXIST',
'pErrorDetails', cStateCube,
'pControl', pControl);

ProcessError;
EndIf;

#***

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');
StringGlobalVariable('gIsActive');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_application_attributes', 'pExecutionId', pExecutionId,
'pAppId', pAppId, 'pControl',  pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'get application attributes', gApprovalDim, gApprovalSubset, gIsActive);
EndIf;

If (gIsActive @<> 'Y');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_APP_NOT_ACTIVE',
'pErrorDetails', pAppId,
'pControl', pControl);

ProcessError;
EndIf;

#* Check node

If (DIMIX(gApprovalDim, pNode) = 0);
ProcessError;
EndIf;

#*** Check user view privilege
StringGlobalVariable('gView');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_user_permissions', 
'pGuid', pExecutionId, 'pApplication', pAppId, 'pNode', pNode, 'pUser', TM1User, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (gView @= 'F');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_NO_PERMISSION',
'pErrorDetails', 'VIEW' | ', ' | pNode,
'pControl', pControl);

ProcessError;
EndIf;

#*** Set state viewed
cViewed = 'Viewed';
CellPutS('Y', cStateCube, pNode, cViewed);

#*** Set state reviewed

cLocked = '4';
cState = 'State';
vValue = CellGetS(cStateCube, pNode, cState);

StringGlobalVariable('gReject');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_user_permissions', 
'pGuid', pExecutionId, 'pApplication', pAppId, 'pNode', pNode, 'pUser', TM1User, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (vValue @= cLocked & gReject @= 'T');
cReviewed = 'Reviewed';
CellPutS('Y', cStateCube, pNode, cReviewed);
EndIf;

#*** Check owner
cWorkInProgress = '2';
cState = 'State';
vValue = CellGetS(cStateCube, pNode, cState);
If (DTYPE(gApprovalDim, pNode) @= 'N' & vValue @= cWorkInProgress);

cCurrentOwner = 'CurrentOwner';
cOwner = CellGetS(cStateCube, pNode, cCurrentOwner);
If (cDisplayUserName @= cOwner);

cBeingEdited = 'BeingEdited';
CellPutS('Y', cStateCube, pNode, cBeingEdited);

cStartEditingDate = 'StartEditingDate';
CellPutS(pTime, cStateCube, pNode, cStartEditingDate);

EndIf;

EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;

573,1

574,1

575,1

576,
638,1
804,0
1217,1
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
